=== removed file '.project'
--- .project	2006-12-11 06:44:19 +0000
+++ .project	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<projectDescription>
-	<name>loggerhead</name>
-	<comment></comment>
-	<projects>
-	</projects>
-	<buildSpec>
-		<buildCommand>
-			<name>org.python.pydev.PyDevBuilder</name>
-			<arguments>
-			</arguments>
-		</buildCommand>
-	</buildSpec>
-	<natures>
-		<nature>org.python.pydev.pythonNature</nature>
-	</natures>
-</projectDescription>

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2008-08-04 03:42:01 +0000
+++ loggerhead/apps/branch.py	2008-08-05 05:17:47 +0000
@@ -28,7 +28,7 @@
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
-        self.branch_link = branch_link
+        self.branch_link = branch_link  # Currently only used in Launchpad
         self.log = logging.getLogger('loggerhead.%s' % (friendly_name,))
         if graph_cache is None:
             graph_cache = bzrlib.lru_cache.LRUCache()

=== modified file 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/filesystem.py	2008-08-01 21:04:29 +0000
+++ loggerhead/apps/filesystem.py	2008-08-05 05:11:33 +0000
@@ -39,14 +39,14 @@
             if self.name:
                 name = self.name
             else:
-                name = os.path.basename(os.path.abspath(self.path))
+                name = '/'
             return DirectoryUI(environ['loggerhead.static.url'], self.path, name)
         else:
             new_path = os.path.join(self.path, segment)
             if self.name:
                 new_name = os.path.join(self.name, segment)
             else:
-                new_name = segment
+                new_name = '/' + segment
             return BranchesFromFileSystemServer(new_path, self.root, new_name)
 
     def __call__(self, environ, start_response):

=== modified file 'loggerhead/static/css/annotate.css'
--- loggerhead/static/css/annotate.css	2008-07-24 22:00:49 +0000
+++ loggerhead/static/css/annotate.css	2008-08-05 19:44:50 +0000
@@ -1,16 +1,13 @@
 /*table*/
 .annoLineTit, .annoLine, .annoRevTit, .annoRev, .annoComm, .annoCommTit, .annoContTit, .annoCont {
-	padding:4px;
 	width:45px;
 	border:1px solid #d2d2d2;
 }
 .annoLine, .annoRev, .annoComm, .annoCont {
-	padding:5px 0px;
 	border:none;	
 }
 .annoLine {
 	width:37px;
-	padding:5px 4px;
 }
 .annoContTit, .annoCont {
 	width:auto;

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2008-07-25 19:23:15 +0000
+++ loggerhead/static/css/global.css	2008-08-05 06:17:12 +0000
@@ -18,11 +18,11 @@
 	outline:none;
 }
 form {
-	margin:0;
-	padding:0;
+  margin: 0;
+  padding: 0;
 }
 tr td {
-    vertical-align:top
+  vertical-align: top;
 }
 .clear {
 	clear:both;
@@ -186,7 +186,6 @@
 	padding:0px 11px 0px 0px;
 	margin:0px 2px 0px 0px;
 	font-weight:bold;
-	background:url(../images/ico_link.gif) right top no-repeat;
 }
 .revnolink a, .revnolink a:visited, .revnolink a:link, .revnolink a:hover {
 	color:#CC6600;
@@ -228,15 +227,15 @@
 .expandcell, .expcell {
 	width:28px;	
 }
-.summarycell, .authorcell, .datecell, .summcell, .autcell, .date, .timedate, .timedate2 {
-	padding:4px 8px;
-	border:1px solid #d2d2d2;
+.summarycell, .authorcell, .datecell, .timedate{
+  padding: 4px 8px;
+  border: 1px solid #d2d2d2;
 }
-.authorcell, .autcell {
-	width:202px;
+.icocell {
+  width: 18px;
 }
 .datecell, .date {
-	width:110px;
+  width: 180px;
 }
 .timedate, .timedate2 {
 	width:80px;
@@ -244,9 +243,10 @@
 .downloadcell, .downr {
 	width:47px;
 }
-.revnro, .expcell, .diffr, .summcell, .autcell, .date, .downr, .allicones, .timedate2 {
-	border:none;
-	border-bottom:1px solid #d2d2d2;
+.revnro, .expcell, .diffr, .summcell, .autcell, .icocell, .date, .downr, .allicones, .timedate2 {
+  border: 0;
+  padding: 4px 4px;
+  border-bottom:1px solid #d2d2d2;
 }
 .revisioninfo {
     margin-top:4px;

=== added file 'loggerhead/static/images/ico_folder_up.gif'
Binary files loggerhead/static/images/ico_folder_up.gif and loggerhead/static/images/ico_folder_up.gif differ
=== modified file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2008-08-04 21:22:16 +0000
+++ loggerhead/templates/directory.pt	2008-08-05 06:12:07 +0000
@@ -14,33 +14,49 @@
       <div >
         <table id="logentries">
           <tr class="logheader">
-            <th class="summarycell">Filename</th>
+            <th class="summarycell" colspan="2">Filename</th>
             <th class="datecell">Latest Rev</th>
             <th class="datecell">Last Changed</th>
           </tr>
           
+          <tr class="blueRow0" tal:condition="python:name != '/'">
+            <td class="icocell">
+                <a href=".."><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>
+            </td>
+            <td class="summcell" colspan="3">
+                <a href="..">..</a>
+            </td>
+          </tr>
           <tal:block repeat="dir dirs">
+
             <tal:branch-row tal:condition="dir/branch">
               <tr tal:attributes="class string:blueRow${dir/parity}">
+                <td class="icocell">
+                    <a tal:attributes="href string:${dir/dirname}/files">
+                        <img tal:attributes="src python:static_url('/static/images/ico_branch.gif')" />
+                    </a>
+                </td>
                 <td class="autcell">
-                  <img tal:attributes="src python:static_url('/static/images/ico_branch.gif')" />
                   <a tal:attributes="href string:${dir/dirname}/files" tal:content="dir/dirname" /></td>
                 <td class="date">
-                  <tal:block tal:condition="dir/branch" tal:content="dir/branch/revno" />
+                  <a tal:attributes="href string:${dir/dirname}/revision/${dir/branch/revno};
+                                     title string:Show revision ${dir/branch/revno}"
+                     tal:content="dir/branch/revno"></a>
                 </td>
                 <td class="date" tal:content="python:util.date_time(dir.last_change)"></td>
               </tr>
             </tal:branch-row>
             <tal:non-branch-row tal:condition="not:dir/branch">
               <tr tal:attributes="class string:blueRow${dir/parity}">
+                <td class="icocell">
+                    <a tal:attributes="href string:${dir/dirname}">
+                        <img tal:attributes="src python:static_url('/static/images/ico_folder.gif')" />
+                    </a>
+                </td>
                 <td class="autcell">
-                  <img tal:attributes="src python:static_url('/static/images/ico_folder.gif')" />
                   <a tal:attributes="href string:${dir/dirname}" tal:content="dir/dirname" /></td>
-                <td class="date">
-                </td>
-                <td class="date" tal:content="dir/last_change">
-                  FIXME: changed date here!
-                </td>
+                <td class="date"></td>
+                <td class="date" tal:content="dir/last_change"></td>
               </tr>
             </tal:non-branch-row>
           </tal:block>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-08-04 03:42:01 +0000
+++ loggerhead/templates/inventory.pt	2008-08-05 06:21:09 +0000
@@ -48,7 +48,8 @@
 
           <tr class="blueRow0" tal:condition="python:updir">
               <td class="summcell" colspan="6">
-                  <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">..</a>
+                  <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_folder_up.gif')" />..</a>
               </td>
           </tr>
           

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2008-07-25 02:06:37 +0000
+++ loggerhead/templates/revisioninfo.pt	2008-08-05 19:25:28 +0000
@@ -13,7 +13,7 @@
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-        <div class="information" tal:content="change/comment"></div>
+        <div class="information" tal:content="python:util.fixed_width(change.comment)"></div>
     </div>
     <ul id="list-files">
         <tal:block condition="nocall:modified_file_link">

=== added file 'serve-branches.1'
--- serve-branches.1	1970-01-01 00:00:00 +0000
+++ serve-branches.1	2008-08-05 16:07:16 +0000
@@ -0,0 +1,29 @@
+.TH LOGGERHEAD "1" "August 2008" "loggerhead 1.6" "User Commands"
+.SH NAME
+loggerhead \- run a loggerhead server
+.SH SYNOPSIS
+.B serve-branches
+[\fIoptions\fR] \fI<path>\fR
+.SH DESCRIPTION
+Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
+a branch history, annotate files, view patches, perform searches, etc. It's 
+heavily based on bazaar-webserve, which is itself based on hgweb for Mercurial.
+.PP
+The serve-branches command runs a standalone loggerhead server in the foreground.
+.SH OPTIONS
+.TP
+\fB\-h\fR, \fB\-\-help\fR
+show this help message and exit
+.TP
+\fB\-\-user\-dirs\fR
+Serve user directories as ~user.
+.TP
+\fB\-\-trunk\-dir\fR=\fIDIR\fR
+The directory that contains the trunk branches.
+.TP
+\fB\-\-version\fR
+Print the software version and exit
+.SH "LICENSE"
+GNU GPLv2 or later.
+.SH "SEE ALSO"
+https://launchpad.net/loggerhead

=== modified file 'setup.py'
--- setup.py	2008-07-31 04:49:15 +0000
+++ setup.py	2008-08-05 16:02:23 +0000
@@ -31,10 +31,17 @@
     maintainer = "Michael Hudson",
     maintainer_email = "michael.hudson@canonical.com",
     scripts = ["start-loggerhead", "stop-loggerhead", "serve-branches"],
-    packages = ["loggerhead"],
-    package_data = {"loggerhead":["templates/*.pt"]},
+    packages = ["loggerhead", 
+                "loggerhead/apps", 
+                "loggerhead/controllers", 
+                "loggerhead/templates"],
+    package_data = {"loggerhead":["templates/*.pt", 
+                                  "static/css/*.css", 
+                                  "static/javascript/*", 
+                                  "static/images/*"]},
     data_files = [
-        ('share/man/man1',['start-loggerhead.1', 'stop-loggerhead.1']),
+        ('share/man/man1',['start-loggerhead.1', 'stop-loggerhead.1', 
+                           'serve-branches.1']),
         ('share/doc/loggerhead', ['loggerhead.conf.example']),
         ],
     )

=== modified file 'start-loggerhead'
--- start-loggerhead	2008-07-26 17:53:10 +0000
+++ start-loggerhead	2008-08-06 18:33:20 +0000
@@ -44,10 +44,9 @@
     return h
 
 
-def setup_logging(home, config, foreground):
+def setup_logging(logdir, config, foreground):
     # i hate that stupid logging config format, so just set up logging here.
 
-    log_folder = os.path.join(home, 'logs')
     if not os.path.exists(log_folder):
         os.mkdir(log_folder)
 
@@ -76,27 +75,33 @@
 
 
 def main():
+    home = os.path.realpath(os.path.dirname(__file__))
+    default_pidfile = os.path.join(home, 'loggerhead.pid')
+    default_configfile = os.path.join(home, 'loggerhead.conf')
+    default_log_folder = os.path.join(home, 'logs')
     parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
     parser.add_option('-f', '--foreground', action='store_true', dest='foreground', default=False,
                       help="run in the foreground; don't daemonize")
     parser.add_option('-C', '--check', action='store_true', dest='check', default=False,
                       help="only start if not already running (useful for cron jobs)")
+    parser.add_option('-p', '--pidfile', dest="pidfile", default=default_pidfile,
+                      help="override pidfile location")
+    parser.add_option('-c', '--config-file', dest="configfile", default=default_configfile,
+                      help="override configuration file location")
+    parser.add_option('-L', '--log-folder', dest="log-folder", default=default_log_folder,
+                      help="override log file directory")
     options, args = parser.parse_args()
     if len(args) > 0:
         parser.error('No filename arguments are used, only options.')
 
-
-    home = os.path.realpath(os.path.dirname(__file__))
-    pidfile = os.path.join(home, 'loggerhead.pid')
-
     if options.check:
-        if daemon.is_running(pidfile):
+        if daemon.is_running(options.pidfile):
             sys.exit(0)
-        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (pidfile,))
+        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (options.pidfile,))
 
     # read loggerhead config
 
-    config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
+    config = ConfigObj(options.configfile, encoding='utf-8')
     extra_path = config.get('bzrpath', None)
     if extra_path:
         sys.path.insert(0, extra_path)
@@ -121,12 +126,12 @@
     if not options.foreground:
         sys.stderr.write('\n')
         sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (pidfile,))
+        sys.stderr.write('PID file: %s\n' % (options.pidfile,))
         sys.stderr.write('\n')
 
-        daemon.daemonize(pidfile, home)
+        daemon.daemonize(options.pidfile, home)
 
-    setup_logging(home, config, foreground=options.foreground)
+    setup_logging(options.log_folder, config, foreground=options.foreground)
 
     log = logging.getLogger('loggerhead')
     log.info('Starting up...')
@@ -151,7 +156,7 @@
     finally:
         log.info('Shutdown.')
         try:
-            os.remove(pidfile)
+            os.remove(options.pidfile)
         except OSError:
             pass
 

=== modified file 'start-loggerhead.1'
--- start-loggerhead.1	2008-07-26 14:09:59 +0000
+++ start-loggerhead.1	2008-08-06 18:33:20 +0000
@@ -23,6 +23,15 @@
 .TP
 \fB\-C\fR, \fB\-\-check\fR
 only start if not already running (useful for cron jobs)
+.TP
+\fB\-p\fR, \fB\-\-pidfile=PIDFILE\fR
+override pid file location
+.TP
+\fB\-c\fR, \fB\-\-config-file=CONFIGFILE\fR
+override configuration file location
+.TP
+\fB\-L\fR, \fB\-\-log-folder=LOG-FOLDER\fR
+override log directory
 .SH "LICENSE"
 GNU GPLv2 or later.
 .SH "SEE ALSO"

=== modified file 'stop-loggerhead'
--- stop-loggerhead	2008-07-26 14:52:44 +0000
+++ stop-loggerhead	2008-08-06 18:39:15 +0000
@@ -15,19 +15,26 @@
 
 """A script for stopping the loggerhead process."""
 
-import pkg_resources
-pkg_resources.require("TurboGears")
-
 import os
 import sys
+from optparse import OptionParser
+
+from loggerhead import release
 
 home = os.path.realpath(os.path.dirname(__file__))
-pidfile = os.path.join(home, 'loggerhead.pid')
+default_pidfile = os.path.join(home, 'loggerhead.pid')
+parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
+parser.add_option('-p', '--pidfile', dest="pidfile", default=default_pidfile,
+				  help="override pidfile location")
+
+options, args = parser.parse_args()
+if len(args) > 0:
+	parser.error('No filename arguments are used, only options.')
 
 try:
-    f = open(pidfile, 'r')
+    f = open(options.pidfile, 'r')
 except IOError, e:
-    print 'No pid file found.'
+    print 'Pid file %s not found.' % options.pidfile
     sys.exit(1)
 
 pid = int(f.readline())

=== modified file 'stop-loggerhead.1'
--- stop-loggerhead.1	2008-07-26 14:09:59 +0000
+++ stop-loggerhead.1	2008-08-06 18:39:15 +0000
@@ -7,6 +7,10 @@
 Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
 a branch history, annotate files, view patches, perform searches, etc. It's 
 heavily based on bazaar-webserve, which is itself based on hgweb for Mercurial.
+.SH OPTIONS
+.TP
+\fB\-p\fR, \fB\-\-pidfile=PIDFILE\fR
+override pid file location
 .PP
 The stop-loggerhead command stops the currently running loggerhead server.
 .SH "LICENSE"

